import java.sql.*;
import java.util.*;
import javax.swing.*;

/**
 * Clase Cliente
 * Clase POJO a ser ser editada utilizando JTable
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */

//@JTableColumn(pageSize=10,queryLoad="SELECT * FROM SP_PCLIENTE(1,5) ORDER BY NROW")
@JTableColumn(pagination=true,pageSize=3,spPageCount="SP_PPCLIENTE",queryLoad="SELECT * FROM SP_PCLIENTE(%pageNumber%,%pageSize%) ORDER BY NROW")
public class Cliente implements JEntity {
    private int codigo;
    private String descr;
    private double saldo;
    private int noexiste;
    
    // constructor
    public Cliente() {
    }
    public Cliente(int c) {
        this(c,"Sin Nombre",0.0);
    }
    public Cliente(int c,String d) {
        this(c,d,0.0);
    }
    public Cliente(int c,String d,double ss) {
        setCodigo(c);setDescr(d);setSaldo(ss);
    }
    public Cliente(ResultSet rs) {
        try {
            setCodigo(rs.getInt("codigo"));setDescr(rs.getString("descr"));setSaldo(rs.getDouble("saldo"));
        } catch (SQLException sqle) {
            System.out.println(DataIO.getErrorMessages());
        }
    }
    
    // getters
    @JColumn(title="Codigo",position=0,primaryKey=true,rangeValidation=true,minRange=1.00,maxRange=8.00)
    public int getCodigo() { return codigo; }
    //@JColumn(title="Descripcion",position=1,width=200,classType=MiCombo.class,sqlQuery="SELECT DESCR,CODIGO FROM CLIENTE ORDER BY DESCR ASC",sqlQueryColumn=0,sqlQueryEmptyRow=true)
    @JColumn(title="Descripcion",position=1,width=200,listStringValidation=true,listString = {"Hola","Chau"})
    public String getDescr() { return descr; }
    //@JColumn(title="Saldo",position=2,rangeValidation=true,minRange=500.00,maxRange=800.00)
    @JColumn(title="Saldo",position=2,listValidation=true,listRange = {1.00,5.00,10.00})
    public double getSaldo() { return saldo; }
    /**@JColumn(title="NoExiste",position=3,classType=MiCombo.class,sqlQuery="SELECT DESCR,CODIGO FROM CLIENTE ORDER BY DESCR ASC",sqlQueryColumn=1,sqlQueryEmptyRow=false)
    public double getNoExiste() { return noexiste; }*/
    // setters
    public void setCodigo(int x) { codigo = x; }
    public void setDescr(String x) { descr = x; }
    public void setSaldo(double x) { saldo = x; }
    public void setNoExiste(int x) { noexiste = x; }
    
    @Override
    public String toString() { 
        return "[codigo="+
            getCodigo()+",descr="+getDescr()+",saldo="+getSaldo()+"]";
    }
    
    @Override
    public boolean doUpdate(Object aValue,List<JEntity> upd,int rowIndex,int columnIndex) {
        switch(columnIndex) {
            case 1:
                String sdescr =  (String) aValue;    
                if ( sdescr == null ) sdescr = "";
                if ( !getDescr().equals(sdescr) ) {
                    setDescr(sdescr);
                    DataIO.executeQuery("UPDATE CLIENTE SET DESCR='"+getDescr()+
                        "' WHERE CODIGO= "+getCodigo());
                    DataIO.doCommit();
                    return true;
                }
                break;
            case 2:
                double nsaldo = (Double) aValue;
                if (nsaldo != getSaldo()) {
                    setSaldo(nsaldo);
                    System.out.println("Lo modifique!");
                    DataIO.executeQuery("UPDATE CLIENTE SET SALDO='"+getSaldo()+
                    "' WHERE CODIGO= "+getCodigo());
                    DataIO.doCommit();
                    return true;
                }
                break;
            case 3:
                    int noexiste = new Integer(((ItemCombo) aValue).getValue());
                    ((Cliente) upd.get(rowIndex)).setNoExiste(noexiste);
                break;
        }
        return false;
    }

    @Override
    public boolean doNew(List<JEntity> upd) {
      ResultSet rs = DataIO.getResultSet("SELECT CODIGO FROM SP_NUEVO");
      try {
          if (rs.next()) {
              Cliente c = new Cliente(rs.getInt("codigo"));
              DataIO.executeQuery("INSERT INTO CLIENTE(CODIGO,DESCR,SALDO) VALUES("
              +c.getCodigo()+",'"+c.getDescr()+"',"+c.getSaldo()+")");
              upd.add(c);
              DataIO.doCommit();
              return true;
          }
      } catch (SQLException sqle) {
            System.out.println(DataIO.getErrorMessages());
            return false;
      }
      return false;
    }
    
    @Override
    public boolean doDelete(List<JEntity> upd) {
      DataIO.executeQuery("DELETE FROM CLIENTE WHERE CODIGO = "+getCodigo());
      DataIO.doCommit();
      upd.remove(this);
      return true;
    }

    @Override
    public JEntity newInstance(ResultSet rs) {
        try {
            Cliente cc = new Cliente();
            cc.setCodigo(rs.getInt("codigo"));cc.setDescr(rs.getString("descr"));cc.setSaldo(rs.getDouble("saldo"));
            return (JEntity) cc;
        } catch (SQLException sqle) {
            System.out.println(DataIO.getErrorMessages());
        }
        return null;
    }

}
