import java.sql.*;
import java.util.*;
import javax.swing.*;
/**
 * Clase Cliente
 * Clase POJO a ser ser editada utilizando JTable
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
@JTableColumn(queryLoad="SELECT * FROM FACTURA WHERE 1 = 2 ORDER BY NRO")
public class Factura implements JEntity {
    private int nro;
    private int codigo;
    
    // constructor
    public Factura() {
    }
    public Factura(int n) {
        this(n,0);
    }
    public Factura(int n,int c) {
        setNro(n);setCodigo(c);
    }
    public Factura(ResultSet rs) {
        try {
            setNro(rs.getInt("nro"));setCodigo(rs.getInt("codigo"));
        } catch (SQLException sqle) {
            System.out.println(DataIO.getErrorMessages());
        }
    }
    
    // getters
    @JColumn(title="Nro",position=0,primaryKey=true,width=5)
    public int getNro() { return nro; }
    @JColumn(title="Codigo",position=1,classType=Integer.class)
    public int getCodigo() { return codigo; }

    // setters
    public void setCodigo(int x) { codigo = x; }
    public void setNro(int x) { nro = x; }
    
    @Override
    public String toString() { 
        return "[nro="+
            getNro()+",codigo="+getCodigo()+"]";
    }
    
    @Override
    public boolean doUpdate(Object aValue,List<JEntity> upd,int rowIndex,int columnIndex) {
        switch(columnIndex) {
            case 1:
                int icodigo = (Integer) aValue;
                if ( icodigo != getCodigo() ) {
                    if ( DataIO.executeQuery("UPDATE FACTURA SET CODIGO='"+icodigo+
                        "' WHERE NRO= "+getNro()) ) {
                            setCodigo(icodigo);
                            DataIO.doCommit();
                            return true;
                    } else {
                        return false;
                    }
                    
                }
                break;
        }
        return false;
    }

    @Override
    public boolean doNew(List<JEntity> upd) {
      ResultSet rs = DataIO.getResultSet("SELECT MAX(A.NRO) AS NRO,MIN(B.CODIGO) AS CODIGO FROM FACTURA A,CLIENTE B");
      try {
          int nro=1;
          int codigo=0;
          if (rs.next()) {
              nro = rs.getInt("nro")+1;
              codigo = rs.getInt("codigo");
          } 
          Factura f = new Factura(nro,codigo);
          rs.close();
          DataIO.executeQuery("INSERT INTO FACTURA(NRO,CODIGO) VALUES("
          +f.getNro()+","+f.getCodigo()+")");
          upd.add(f);
          DataIO.doCommit();
          return true;
      } catch (SQLException sqle) {
            DataIO.doException(sqle,"Error en Factura.doNew()");
            return false;
      }
    }
    
    @Override
    public boolean doDelete(List<JEntity> upd) {
      DataIO.executeQuery("DELETE FROM FACTURA WHERE NRO = "+getNro());
      DataIO.doCommit();
      upd.remove(this);
      return true;
    }

    @Override
    public JEntity newInstance(ResultSet rs) {
        Factura ff = new Factura(rs);
        return (JEntity) ff;
    }

}
