import java.lang.annotation.*; 
/**
 * Declaracion de anotacion propia que sirve para que otra clase
 * inyecte referencia a archivos secuenciales de entrada y salida
 * a ser utilizados en un proceso de tipo batch
 * 
 * @author G.Cherencio
 * @version 1.0
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.METHOD)
@Inherited  
@interface JColumn
{
	int width() default 100;
	String title() default "";
	Class classType() default Void.class;
	int position() default 0;
	boolean primaryKey() default false;
	String sqlQuery() default "";
	int sqlQueryColumn() default -1;
	boolean sqlQueryEmptyRow() default false;
	boolean rangeValidation() default false;
	double minRange() default -1.00;
	double maxRange() default -1.00;
	boolean listValidation() default false;
	double[] listRange() default {};
	boolean listStringValidation() default false;
	String[] listString() default {};
}
