import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.*;
import javax.swing.*;
import javax.swing.event.*;
import java.sql.*;
import javax.swing.table.*;
import java.lang.annotation.*;
import java.lang.reflect.*;

/**
 * Write a description of class MiTableModel here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MiTableModel extends AbstractTableModel implements KeyListener, ListSelectionListener
{
  private ArrayList<JEntity> upd = new ArrayList<JEntity>();
  private JTable tbl;
  private boolean edito=true;
  private ViewTable view;
  private JScrollPane jsp;
  private String sEntidad;
  private Class<?> EntityClass;
  private int columnCount=0;
  private Method[] met;
  private Class[] columnClass;
  private int[] columnWidth;
  private String[] columnTitle;
  private boolean[] columnPK;
  private JEntity entity;
  private String queryLoad = null;
  private String[] sqlQuery;
  private int[] sqlQueryColumn;
  private boolean[] sqlQueryEmtpyRow;
  private MiCombo[] combos;
  private ArrayList<MiRowListener> lst = new ArrayList<MiRowListener>();
  private boolean[] rangeValidation;
  private double[] minRange;
  private double[] maxRange;
  private boolean[] listValidation;
  private double[][] listRange;
  private boolean[] listStringValidation;
  private String[][] listString;
  
  private int maxNumberPages = -1;
  private int currentPageNumber = -1;
  private int pageSize = -1;
  private String spPageCount = "";
  private boolean pagination = false;
  
  public MiTableModel() {}
  public MiTableModel(JTable t,String sEntidad) {
      this.sEntidad=sEntidad;
      EntityClass = DoReflection.getClass(sEntidad);
      columnCount = DoReflection.getAnnotationJColumnCount(EntityClass);
      entity = (JEntity) DoReflection.newObject(EntityClass);
      met = DoReflection.getMethodColumn(EntityClass);
      columnClass = DoReflection.getColumnClass(met);
      columnWidth = DoReflection.getColumnInt(met,"width");
      columnTitle = DoReflection.getColumnString(met,"title");
      columnPK = DoReflection.getColumnBoolean(met,"primaryKey");
      queryLoad = DoReflection.getQueryLoad(EntityClass);
      sqlQuery = DoReflection.getColumnString(met,"sqlQuery");
      sqlQueryColumn = DoReflection.getColumnInt(met,"sqlQueryColumn");
      sqlQueryEmtpyRow = DoReflection.getColumnBoolean(met,"sqlQueryEmptyRow");
      minRange = DoReflection.getColumnDouble(met,"minRange");
      maxRange = DoReflection.getColumnDouble(met,"maxRange");
      listRange = DoReflection.getColumnListDouble(met,"listRange");
      rangeValidation = DoReflection.getColumnBoolean(met,"rangeValidation");
      listValidation = DoReflection.getColumnBoolean(met,"listValidation");
      listStringValidation = DoReflection.getColumnBoolean(met,"listStringValidation");
      listString = DoReflection.getColumnListString(met,"listString");
      
      pageSize = DoReflection.getPageSize(EntityClass);
      spPageCount = DoReflection.getSpPageCount(EntityClass);
      pagination = DoReflection.getPagination(EntityClass);
      
      combos = new MiCombo[met.length];
      tbl = t;
      tbl.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      tbl.setModel(this);
      addCombo();
      setColumnWidth();
      jsp = new JScrollPane(tbl,
            ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
            ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
      tbl.addKeyListener(this);
      tbl.getSelectionModel().addListSelectionListener(this);
      doRefresh();
  }
  
  //getters
  public String getQueryLoad() { return queryLoad; }
  public String[] getSqlQuery() { return sqlQuery; }           
  public Class[] getColumnClass() { return columnClass; }
  public int[] getColumnWidth() { return columnWidth; }
  public String[] getColumnTitle() { return columnTitle;}
  public boolean[] getColumnPK() { return columnPK; }
  public int[] getSqlQueryColumn() { return sqlQueryColumn; }
  public JScrollPane getScrollPane() { return jsp; }
  public JTable getTable() { return tbl; }
  public String getSentidad() { return sEntidad; }
  public JEntity getEntity() { return entity; }
  public ArrayList<JEntity> getArrayList() { return upd; }
    
  //setters
  public void setQueryLoad(String q) { queryLoad = q; }
  public void setSqlQuery(String[] q) { sqlQuery = q; }
  public void setColumnClass(Class[] c) { columnClass = c; }
  public void setColumnWidth(int[] cw) { columnWidth = cw; }
  public void setColumnTitle(String[] ct) { columnTitle = ct; }
  public void setColumnPK(boolean[] cp) { columnPK = cp; }
  public void setSqlQueryColumn(int[] sqc) { sqlQueryColumn = sqc; }
  public void setJScrollPane(JScrollPane jsp) { jsp = jsp; }
  public void setTable(JTable jt) { tbl = jt; }
  public void setSentdidad(String se) { sEntidad = se; }
  public void setJEntity(JEntity je) { entity = je; }
  public void setArrayList(ArrayList<JEntity> al) { upd = al; }
  public void setPageSize(int p) { pageSize = p; }
  public void setSpPageCount(String s) { spPageCount = s; }
  public void setMaxNumberPages (int i) { maxNumberPages = i; }
 
  // agrego las combos que sean necesarias
  private void addCombo() {
      int i=0;
      for(String q : sqlQuery) {
          if ( !q.equals("") ) {
              //
              System.out.println("MiCombo(q,"+sqlQueryColumn[i]+","+sqlQueryEmtpyRow[i]+")");
              combos[i] = new MiCombo(q,sqlQueryColumn[i],sqlQueryEmtpyRow[i]);
              TableColumn tc = tbl.getColumnModel().getColumn(i);
              tc.setCellEditor(new DefaultCellEditor(combos[i]));
              
          }
          i++;
      }
  }
  
  private void setColumnWidth() {
      int i=0;
      for(int w : columnWidth ) {
          if ( w != -1 ) tbl.getColumnModel().getColumn(i).setPreferredWidth(w);
          i++;
      }
  }
  
  public void addRowListener(MiRowListener mrl) {
      lst.add(mrl);
  }
  public int getRowCount() {
      return upd.size();
  }
  // puede hacerse con anotacion o inferirse de otras anotaciones
  public int getColumnCount() {
      return columnCount;
  }
  
  // puede hacerse con anotacion
  public Object getValueAt(int row, int column) {
    try {
        return met[column].invoke(upd.get(row));
    } catch(IllegalAccessException i) {
        System.err.println("MiTableModel.getValueAt("+row+","+column+") IllegalAccessException");
        return null;
    } catch(IllegalArgumentException i2) {
        System.err.println("MiTableModel.getValueAt("+row+","+column+") IllegalArgumentException");
        return null;
    } catch(InvocationTargetException i3) {
        System.err.println("MiTableModel.getValueAt("+row+","+column+") InvocationTargetException");
        return null;
    }
  }
  
  public Class<?> getColumnClass(int column) {
      return columnClass[column];
  }
  
  // puede hacerse con anotacion
  public String getColumnName(int column) {
    return columnTitle[column];
  }
  
  // puede hacerse con anotacion  FALTA RESOLVER !!!
  public boolean isCellEditable(int rowIndex,int columnIndex) {
    if ( columnPK[columnIndex] ) return false;
    if ( edito ) return !columnPK[columnIndex];
    else { edito=true;return !columnPK[columnIndex]; }
  }
  
  // necesitamos un metodo en una interfase que luego la implemente la clase pojo a persistir
  public void setValueAt(Object aValue,int rowIndex,int columnIndex) {
      JEntity en = null;
      if (rangeValidation[columnIndex]) {
        if(doValidate(aValue,columnIndex))en = upd.get(rowIndex);
      } else if (listValidation[columnIndex]) {
        if(doListValidate(aValue,columnIndex)) en = upd.get(rowIndex);         
      } else if (listStringValidation[columnIndex]) {
        if(doStringListValidate(aValue,columnIndex)) en = upd.get(rowIndex);                   
      } else {
        en = upd.get(rowIndex);  
      }
      
      if ( en != null && en.doUpdate(aValue,upd,rowIndex,columnIndex) ) fireTableCellUpdated(rowIndex,columnIndex);
  }

  // puede hacerse con anotacion
   public boolean doRefresh() {
       if ( queryLoad != null ) {
           if ( !queryLoad.equals("") ) {
               if( pagination ) {
                  ResultSet rsPages = DataIO.getResultSet("SELECT NPAGES FROM "+spPageCount+"("+pageSize+")");
                  try {
                      while(rsPages.next()) {
                          setMaxNumberPages(rsPages.getInt("npages"));
                          if(currentPageNumber == -1) {
                              currentPageNumber = 1;
                          }
                      }
                      rsPages.close();
                  } catch (SQLException sqle) {
                      System.out.println(DataIO.getErrorMessages());
                      return false;
                   }
                  ResultSet rs = DataIO.getResultSet("SELECT * FROM SP_PCLIENTE("+currentPageNumber+","+pageSize+")");
                  try {
                      upd.clear();
                      while(rs.next()) {
                          upd.add(  entity.newInstance(rs)  );
                      }
                      rs.close();
                      fireTableDataChanged();
                      if ( tbl != null ) {
                          if ( upd.size() > 0 ) { 
                              tbl.setRowSelectionInterval(0,0);
                              doRowSelection(0);
                          }
                          tbl.setEditingRow(-1);
                      }
                      return true;
                  } catch (SQLException sqle) {
                      System.out.println(DataIO.getErrorMessages());
                      return false;
                  }     
               } else {
                   ResultSet rs = DataIO.getResultSet(queryLoad);
                   try {
                       upd.clear();
                       while(rs.next()) {
                           upd.add(  entity.newInstance(rs)  );
                       }
                       rs.close();
                       fireTableDataChanged();
                       if ( tbl != null ) {
                           if ( upd.size() > 0 ) { 
                               tbl.setRowSelectionInterval(0,0);
                               doRowSelection(0);
                           }
                           tbl.setEditingRow(-1);
                       }
                       return true;
                   } catch (SQLException sqle) {
                       System.out.println(DataIO.getErrorMessages());
                       return false;
                   }     
               }
          }
      }
      return false;
  }
  // necesitamos un metodo en un interfase que luego la implemente la clase pojo a persistir
  public boolean doNew() {
    if ( entity.doNew(upd) ) {
        edito=false;
        fireTableRowsInserted(upd.size()-1,upd.size());
        tbl.setRowSelectionInterval(upd.size()-1,upd.size()-1);
        tbl.setEditingRow(-1);
        return true;
    }
    return false;
  } 
    
  // necesitamos un metodo en un interfase que luego la implemente la clase pojo a persistir
  public void doDelete() {
      JEntity en = upd.get(tbl.getSelectedRow());
      if ( en.doDelete(upd) ) {
          int d = tbl.getSelectedRow()-1;
          if ( d < 0 ) d = 0;
          fireTableRowsDeleted(d,d+1);
          edito=false;
          if (upd.size() > 0) {
              tbl.setRowSelectionInterval(d,d);
              tbl.setEditingRow(-1);
          }
      }
  }
 
  //implemento la interface KeyListener
  public void keyTyped(KeyEvent e) {
  }

  public void keyPressed(KeyEvent e) {
      if ( !tbl.isEditing() && e.getKeyCode() == KeyEvent.VK_INSERT ) {
          System.out.println("keyPressed() insert!");
          doNew();
        }
                
      if ( !tbl.isEditing() && e.getKeyCode() == KeyEvent.VK_DELETE ) {
          System.out.println("keyPressed() delete!");
          if ( tbl.getSelectedRow() != -1 ) doDelete();
      }
          
      if ( !tbl.isEditing() && e.getKeyCode() == KeyEvent.VK_F5 ) {
          System.out.println("keyPressed() F5!");
          doRefresh();
      }
      
      if ( !tbl.isEditing() && e.getKeyCode() == KeyEvent.VK_F1 ) {
         System.out.println("keyPressed() F1!");
         JOptionPane.showMessageDialog(null,
          "[F2] Editar\n[F5] Actualizar\n[Insert] Nuevo cliente\n[Delete] Borrar cliente");
      }
      
      if ( !tbl.isEditing() && e.getKeyCode() == KeyEvent.VK_PAGE_UP ) {
          System.out.println("keyPressed() RE.PAG!");
          if(currentPageNumber < maxNumberPages) {
              currentPageNumber++;
              doRefresh();
              System.out.println("Incremente currentPageNumber: "+currentPageNumber);
          }
      }
      
      if ( !tbl.isEditing() && e.getKeyCode() == KeyEvent.VK_PAGE_DOWN ) {
          System.out.println("keyPressed() AV.PAG!");
          if(currentPageNumber > 1) {
              currentPageNumber--;
              doRefresh();
              System.out.println("Decremente currentPageNumber: "+currentPageNumber);
          }
      }
  }

  public void keyReleased(KeyEvent e) {
  }
  
  public static final long serialVersionUID = 42L;  //esta clase es serializable

  // implemento ListSelectionListener
  public void valueChanged(ListSelectionEvent e) {
    ListSelectionModel lsm = (ListSelectionModel) e.getSource();
    int firstIndex = e.getFirstIndex();
    int lastIndex = e.getLastIndex();
    boolean isAdjusting = e.getValueIsAdjusting();
        if (!lsm.isSelectionEmpty()) {
            if ( !isAdjusting ) {
                // Find out which indexes are selected.
                // minIndex y maxIndex deberian ser iguales si la JTable trabaja en modo
                // de seleccion simple (una unica fila seleccionada, no permite seleccionar
                // mas de una al mismo tiempo)
                int minIndex = lsm.getMinSelectionIndex();
                int maxIndex = lsm.getMaxSelectionIndex();
                for (int i = minIndex; i <= maxIndex; i++) {
                    if (lsm.isSelectedIndex(i)) {
                        doRowSelection(i);
                    }
                }
            }
        }
  }   
  
  public void doRowSelection(int i) {
      JEntity entity = null;
      if ( upd.size() > 0 ) {
            entity = upd.get(i);
        } else {
            i = -1;
        }
      // trace
      System.out.println("MiTableModel.valueChanged()doRowSelection():Selecciono " +i+" "+entity);
      // Notifico a todos los row listeners registrados
      for ( MiRowListener mrl : lst ) {
          mrl.selectRow(i,entity,this);
      }
  }
    
  public boolean doValidate(Object aValue,int columnIndex) {
        boolean ret=true;
        if ( rangeValidation[columnIndex] ) {
            if ( aValue instanceof Short ) {
                short n = (Short) aValue;
                ret = n >= (short) minRange[columnIndex] && n <= (short) maxRange[columnIndex];
            } else if ( aValue instanceof Integer ) {
                int n = (Integer) aValue;
                ret =  n >= (int) minRange[columnIndex] && n <= (int) maxRange[columnIndex];
            } else if ( aValue instanceof Long ) {
                long n = (Long) aValue;
                ret = n >= (long) minRange[columnIndex] && n <= (long) maxRange[columnIndex];
            } else if ( aValue instanceof Float ) {
                float n = (Float) aValue;
                ret = n >= (float) minRange[columnIndex] && n <= (float) maxRange[columnIndex];
            } else if ( aValue instanceof Double ) {
                double n = (Double) aValue;
                ret = n >= minRange[columnIndex] && n <= maxRange[columnIndex];
            } else {
                System.err.println("MiTableModel.doValidate(): Error, type validation not implemented!");
                return false;
            }
            if ( !ret ) JOptionPane.showMessageDialog(null,"Valor Ingresado fuera de rango! ("+minRange[columnIndex]+","+maxRange[columnIndex]+")",
            "Error",JOptionPane.ERROR_MESSAGE);
            return ret;
        } else return true;
  }
  
  public boolean doListValidate(Object aValue,int columnIndex) {
      boolean ret = false;
      StringBuilder sb = new StringBuilder("[");
      String coma = ",";
      if(listValidation[columnIndex]) {
          if(aValue instanceof Integer) {
              int n = (Integer) aValue;
              for(int j=0;j<listRange[columnIndex].length;j++){
                int l = (int) listRange[columnIndex][j];
                if (l == n) {
                    ret = true;
                    break;
                }
                if ( j == (listRange[columnIndex].length-1) ) coma="";
                sb.append(listRange[columnIndex][j]+coma);            
              }
              sb.append("]");                              
          } else if(aValue instanceof Double) {
              double n = (Double) aValue;
              for(int j=0;j<listRange[columnIndex].length;j++){
                double l = listRange[columnIndex][j];
                if (l == n) {
                    ret = true;
                    break;
                }
                if ( j == (listRange[columnIndex].length-1) ) coma="";
                sb.append(listRange[columnIndex][j]+coma);                            
              }
              sb.append("]");                              
          } else {
              System.err.println("MiTableModel.doValidate(): Error, type validation not implemented!");
              return false;
          }
          
          if ( !ret ) JOptionPane.showMessageDialog(null,""+aValue+ " no esta en la lista!\n"+sb,
            "Error",JOptionPane.ERROR_MESSAGE);
      } else return true;
      return ret;
  }
  
  public boolean doStringListValidate(Object aValue,int columnIndex) {
      boolean ret = false;
      StringBuilder sb = new StringBuilder("[");
      String coma = ",";
      if(listStringValidation[columnIndex]) {
          if(aValue instanceof String) {
              String n = (String) aValue;
              int j;
              for(j=0;j<listString[columnIndex].length;j++){
                //String l = listString[columnIndex][j];
                if (n.equals(listString[columnIndex][j])) {
                    ret = true;
                    break;
                }
                if ( j == (listString[columnIndex].length-1) ) coma="";
                sb.append(listString[columnIndex][j]+coma);                
              }
              sb.append("]");                
          } else {
              System.err.println("MiTableModel.doValidate(): Error, type validation not implemented!");
              return false;
          }
                   
          
          if ( !ret ) JOptionPane.showMessageDialog(null,""+aValue+" no esta en la lista\n"+sb,
            "Error",JOptionPane.ERROR_MESSAGE);
      } else return true;
      return ret;
  }
  
}
