import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
/**
 * Write a description of class AgendaEspecifica here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class AgendaGenerica extends JFrame
{
    // instance variables - replace the example below with your own
    private int registro;
    private int largo; // 1 estado + ?? no se sabe, depende de estructura.dat
    private RandomAccessFile raf = null;
    private JTextField txt_registro = new JTextField("");
    private JLabel lbl_campo = new JLabel("");
    private JButton btn_alta = new JButton("Grabar");
    private JButton btn_baja = new JButton("Borrar");
    private JButton btn_cancel = new JButton("Cancelar");
    private Hashtable campos = new Hashtable();
    private int campo_nro = 0;
    private int cantidad_de_campos = 0;
    private JTextField[] txts;
    private JLabel[] lbls;
    /**
     * Constructor for objects of class AgendaEspecifica
     */
    public AgendaGenerica() {
        // initialise instance variables
        super("Agenda Generica");
        Container cp = getContentPane();
        JPanel pl = new JPanel();
        JPanel plinf = new JPanel();
        File f = new File("estructura.dat");
        plinf.setLayout(new GridLayout(1,3));
        if ( !f.exists() ) { new AgendaEspecificaCampos();return; }
        cargoEstructura();
        cantidad_de_campos = campos.size();
        if ( cantidad_de_campos == 0 ) {
            f.delete();
            System.out.println("Estructura de campos Vacia!");
            System.exit(1);
        }
        pl.setLayout(new GridLayout((cantidad_de_campos + 1),2));
        txts = new JTextField[cantidad_de_campos];
        lbls = new JLabel[cantidad_de_campos];
        largo=1;
        for(int i=1;i<=cantidad_de_campos;i++) {
            Campo cmp = (Campo) campos.get(new Integer(i));
            txts[i-1] = new JTextField("");
            lbls[i-1] = new JLabel(cmp.getNombre());
            largo+=cmp.getLargo();
        }
        
        txt_registro.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                Integer i = null;
                try { 
                    i = new Integer(txt_registro.getText());
                    if ( i.intValue() >= 0 ) {
                        registro = i.intValue();
                        leer();
                        activoCampos(true);
                        txts[0].requestFocus();
                        txt_registro.setEnabled(false);
                        activoBotones(true);
                    } else {
                        muestroError(txt_registro.getText() + " no es un numero entero entre 0 y n",txt_registro);
                    }
                } catch(NumberFormatException nfe) {
                    muestroError(txt_registro.getText() + " no es un numero entero entre 0 y n",txt_registro);
                }
            }
        });
        btn_alta.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if ( valido() ) { 
                    System.out.println("grabar()");
                    grabar();
                    System.out.println("fin grabar()");
                    txt_registro.setEnabled(true);
                    txt_registro.requestFocus();
                    activoBotones(false);
                    activoCampos(false);
                }
            }
        });
        btn_baja.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                 System.out.println("borrar()");
                 borrar();
                 System.out.println("fin borrar()");
                 txt_registro.setEnabled(true);
                 txt_registro.requestFocus();
                 activoBotones(false);
                 activoCampos(false);
            }
        });
        btn_cancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                 txt_registro.setEnabled(true);
                 txt_registro.requestFocus();
                 activoBotones(false);
                 activoCampos(false);
            }
        });
        
        pl.add(new JLabel("Posicion:"));
        pl.add(txt_registro);
        for(int i=0;i<cantidad_de_campos;i++) {
            pl.add(lbls[i]);
            pl.add(txts[i]);
        }
        plinf.add(btn_alta);
        plinf.add(btn_baja);
        plinf.add(btn_cancel);
            
        addWindowListener(new WindowAdapter() {
            public void windowClosing() {
                cerrar();
                System.exit(0);
            }
        });
        cp.add(pl,"Center");
        cp.add(plinf,"South");
        cp.add(new JLabel("Agenda Generica"),"North");
        // ver tema tama�o vs cantidad de campos
        setSize(400,300);
        setLocation(new Point(200,200));
        setVisible(true);
        vinculoArchivo("agenda.dat");
        activoCampos(false);
        activoBotones(false);
    }
//GETTERS
    
//SETTERS
//CUSTOM
    private void vinculoArchivo(final String txt) {
        try {
            raf = new RandomAccessFile(txt,"rw");
        } catch(IOException ioe) {
            System.out.println("Error " + ioe + " intentando abrir archivo " + txt);
        }
    }
    /**
     * An example of a method - replace this comment with your own
     * 
     * @param  y   a sample parameter for a method
     * @return     the sum of x and y 
     */
    public void cerrar() {
        try { raf.close(); } catch(IOException ioe) {}
    }
    public void leer() {
        Campo cmp = null;
        byte[] tmp;
        for(int i=0;i<cantidad_de_campos;i++) txts[i].setText("");
        try {
            raf.seek(registro * largo);
            if ( raf.readBoolean() ) { // registro activo
                for(int i=0;i<cantidad_de_campos;i++) {
                    cmp = (Campo) campos.get(new Integer(i+1));
                    tmp = new byte[cmp.getLargo()];
                    raf.read(tmp);
                    txts[i].setText(new String(tmp));
                }
            }
        } catch(IOException ioe) {
        }
    }
    public void grabar() {
        Campo cmp = null;
        byte[] tmp;
        byte[] tmp2;
        try {
            raf.seek(registro * largo);
            System.out.println("grabar boolean");
            raf.writeBoolean(true); // registro activo
            for(int i=0;i<cantidad_de_campos;i++) {
                cmp = (Campo) campos.get(new Integer(i+1));
                tmp = txts[i].getText().getBytes();
                tmp2 = new byte[cmp.getLargo()];
                System.arraycopy(tmp,0,tmp2,0,tmp.length);
                for(int ii = tmp.length;ii<cmp.getLargo();ii++) tmp2[ii] = ' ';
                System.out.println("grabando campo " + (i+1));
                raf.write(tmp2);
            }
        } catch(IOException ioe) {
            System.out.println("Error " + ioe + " grabando registro " + registro);
        }
    }
    public void borrar() {
        try {
            raf.seek(registro * largo);
            System.out.println("borrar boolean");
            raf.writeBoolean(false); // registro borrado 
        } catch(IOException ioe) {
            System.out.println("Error " + ioe + " borrando registro " + registro);
        }
    }
    public static void main(String[] arg) {
        new AgendaGenerica();
    }
    public void activoCampos(final boolean b) {
        for(int i = 0;i<cantidad_de_campos;i++) txts[i].setEnabled(b);
    }
    public void activoBotones(final boolean b) {
        btn_alta.setEnabled(b);
        btn_baja.setEnabled(b);
        btn_cancel.setEnabled(b);
    }
    public boolean valido() {
        Campo cmp = null;
        for(int i = 0;i<cantidad_de_campos;i++) {
            cmp = (Campo) campos.get(new Integer(i+1));
            if ( txts[i].getText().length() == 0 ) return muestroError("Debe Ingresar " + cmp.getNombre(),txts[i]);
            if ( txts[i].getText().length() > cmp.getLargo() ) return muestroError(cmp.getNombre() + " no puede superar los " + cmp.getLargo() + " caracteres",txts[i]);
        }
        return true;
    }
    public boolean muestroError(final String msg,final JComponent comp) {
        JOptionPane.showMessageDialog(null, msg, "Agenga Generica - Error", JOptionPane.ERROR_MESSAGE); 
        comp.requestFocus();
        return false;
    }
    private void cargoEstructura() { // carga estructura generica de campos
        vinculoArchivo("estructura.dat");
        long nreg = 0;
        byte[] bcmp = new byte[60];
        String cmp = null;
        int largo = 0,ncampo = 0;
         try {
            while(true) {
                raf.seek(nreg * 65);
                if ( raf.readBoolean() ) { // registro activo
                    raf.read(bcmp);
                    largo = raf.readInt();
                    cmp = new String(bcmp);
                    cmp = cmp.trim();
                    ncampo++;
                    campos.put(new Integer(ncampo),new Campo(ncampo,cmp,largo));
                }
                nreg++;
            }
        } catch(IOException ioe) {
        }
        cerrar();
    }
}
class Campo {
    private int nro;
    private String nombre;
    private int largo;
    private String valor;
    public Campo(final int nro,final String nombre,final int largo) {
        setNro(nro);
        setNombre(nombre);
        setLargo(largo);
        setValor("");
    }
    // GETTERS
    public int getNro() { return nro;}
    public String getNombre() { return nombre;}
    public String getValor() { return valor;}
    public int getLargo() { return largo;}
    // SETTTERS
    public void setNro(final int nro) { this.nro = nro;}
    public void setNombre(final String nombre) { this.nombre = nombre;}
    public void setLargo(final int largo) { this.largo = largo;}
    public void setValor(final String valor) { this.valor = valor;}
    // CUSTOM
}