import java.io.*;
/**
 * En este programa podemos observar varias cosas:<br>
 * * System.in es de tipo InputStream, InputStream es un flujo (stream) de entrada (input) de 8 bits,
 * orientado a byte, posee el metodo read() que devuelve un int que representa el caracter leido de la consola,
 * por supuesto, ese int lo podemos forzar (typecast - casting - "castear") a char para tener el caracter leido,
 * el tema es que, System.in.read() habilita el buffer de teclado, entonces podemos tipear mas de un caracter que
 * quedaran en buffer de teclado. De hecho, si decidimos tipear un solo caracter, para terminar el ingreso debemos
 * presionar la tecla Intro, asi que, tambien estamos ingresando 2 caracteres. El sengundo caracter ingresado (en este
 * caso, Intro '\n') sera lo que devuelva el proximo System.in.read() que hagamos, incluso el buffer de teclado permanece
 * de ejecucion en ejecucion de programa. Desarrolle un pequeo programa que haga ingresos de teclado utilzando 
 * System.in.read() para reproducir lo anterior.
 * Bien, una forma de evitar este "efecto" del buffer de teclado, es trabajar a nivel de linea, tomar el conjunto de caracteres
 * tipeados en la consola, de manera de leer completamente el buffer de teclado y que este no quede "cargado" con caracteres para
 * la proxima ejecucion. Para ello, podemos utilizar la clase InputStreamReader(), esta clase es una especie de conversor, de 
 * traductor de streams de 8 bits (por ello su nombre comienza con InputStream, que da la idea de un stream de input de 8 bits) a
 * un stream de 16 bits (por ello se agrega al nombre la sigla Reader, que da la idea de un stream de input de 16 bits). Entonces,
 * podemos convertir de InputStream de 8 bits a InputStreamReader de 16 bits.  La clase BufferedReader (ya su nombre nos indica, 
 * stream de 16 bits, de input y con uso de un buffer) debido a la utilizacion de un buffer para ir acumulando los caracteres que va
 * leyendo es mucho mas eficiente, tiene mejor performance, esta clase acumulara los caracteres ingresados por teclado y nos permitira
 * luego leerlos "todos juntos y en forma de linea" a traves del metodo readLine() que devuelve un String.<br>
 * * Utilizamos la clase wrapper Integer para convertir de String a int  (de objeto a tipo de dato primitivo)<br>
 * * No hacemos tratamiento de excepciones de tipo IOException<br>
 * * Hacemos tratamiento de excepciones NumberFormatException que puede ser lanzada (throws) cuando intentamos crear un objeto de tipo 
 * Integer a partir del String ingresado por el usuario<br>
 * * El uso de ++ como prefijo y sufijo
 * * Uso de break y continue con etiquetas
 * * 
 * @author Guillermo Cherencio
 * @version 1.0
 */
public class Ciclos
{
    /**
     * An example of a method - replace this comment with your own
     * 
     * @param  y   a sample parameter for a method
     * @return     the sum of x and y 
     */
    public static void main(String[] args) throws IOException { // System.in.read(), new BufferedReader(),  throws java.io.IOException
        char car;
        PrintStream o = System.out;  // para no estar escribiendo tanto System.out.
        o.println("1) Ingrese Numero: (switch 1,2,3,default sin breaks) ");
        // caracter tipeado:
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in)); //IOE
        String linea = in.readLine();
        if ( linea.length() >= 1 ) {
            car = linea.charAt(0);
            switch(car) {
                case '1':
                    o.println("switch entre en 1");
                case '2':
                    o.println("switch entre en 2");
                case '3':
                    o.println("switch entre en 3");
                default:
                    o.println("switch entre en default");
            }
            
        } else o.println("1) Debe tipear al menos un caracter");

        o.println("2) Ingrese Numero: (switch 1,2,3,default con breaks) ");
        // caracter tipeado:
        linea = in.readLine();
        if ( linea.length() >= 1 ) {
            car = linea.charAt(0);
            switch(car) {
                case '1':
                    o.println("switch entre en 1");break;
                case '2':
                    o.println("switch entre en 2");break;
                case '3':
                    o.println("switch entre en 3");break;
                default:
                    o.println("switch entre en default");
            }
            
        } else o.println("2) Debe tipear al menos un caracter");
        
        o.println("3) Ingrese Numero (n): ( do { ...;n++; } while(n<6); )");
        // caracter tipeado:
        linea = in.readLine();
        int n;
        try {
           Integer entero = new Integer(linea);
           n = entero.intValue();
           int pase = 0;
           do {
               o.println("3) Estoy en bucle do {...} while(n<6) n vale " + n + " (antes de ejecutar n++;) " + (++pase) + " veces");
               n++;
           } while (n<6);
           o.println("3) sali de bucle");
        } catch(NumberFormatException nfe) {
            o.println("Maldicion, ingreso " + linea + " y esto no parece ser un int");
        }
        
        
        o.println("4) Ingreso en loop:  n=1; do { ...;n++; } while(n<5) que tiene en su interior break y continue");
//        bucle1: //si ponemos la etiqueta aqui da error de compilacion, para continue se requiere que haya un bucle luego de la etiqueta
        bucle44: // puedo crear una etiqueta en cualquier linea
        n=1;
        int loopeo = 0;
        bucle1:  // puesta aqui la etiqueta compila ok
        do {
/* 
 * estas lineas estan comentadas para no alterar la logica de este programa, pero son lineas totalmente validas, compilan
 * al interior de bucle2 puedo decir break bucle1 porque dicha instruccion break esta contenida dentro del bucle1
 * tambien puedo decir break bucle2 porque dicha instruccion break tambien esta contenida dentro del bucle bucle2
            bucle2:
            do {n++;break bucle1;break bucle2;} while(true);
*/            
            o.println("4) cuando n == 4 hago continue bucle1; n vale " + n + "(antes de ejecutar n++;) ");
            if ( loopeo == 10) { 
                o.println("4) el continue provoco un loop infinito, lo corto con break bucle1; luego de 10 iteraciones"); 
/* 
 * sacando el comentario anterior, es decir creando otro bucle anidado dentro de bucle1 llamado bucle2, la siguiente instruccion 
 *              break bucle2;
 * puesta en este lugar es invalida, no compila porque dicha instruccion break esta contenida dentro del bucle bucle1, pero no 
 * esta dentro de bucle2, por lo tanto el compilador da error y no reconoce a bucle2 como una etiqueta
 */
                break bucle1; 
            }
            if ( n == 4 ) {
                loopeo++;
                continue bucle1; 
            }
            n++;
        } while (n<5);
        o.println("4) sali de bucle");

        o.println("5) Ingrese Numero (n): ( while(n<6) { ...;n++; } )");
        // caracter tipeado:
        linea = in.readLine();
        try {
           Integer entero = new Integer(linea);
           n = entero.intValue();
           int pase = 0;
           while (n < 6) {
               o.println("5) Estoy en bucle while (n<6) {...} n vale " + n + " (antes de ejecutar n++;) " + (++pase) + " veces");
               n++;
           }
           o.println("5) sali de bucle");
        } catch(NumberFormatException nfe) {
            o.println("Maldicion, ingreso " + linea + " y esto no parece ser un int");
        }

        o.println("Fin de Programa");
    }
}
