import java.io.*;
import java.awt.*;
/**
 * Java forma los colores usando combinaciones de red,green,blue (RGB)
 * Que combinacion de RGB son los colores que pueden obtenerse a traves
 * de los atributos static de la clase java.awt.Color?
 * Clase static, no se espera crear objetos de esta clase
 * @author G.Cherencio
 * @version 1.0
 */
public class Colors {
    // instance variables - replace the example below with your own
    private static Color[] col = new Color[13];
    private static String[] colname = new String[13];
    static {
        build();
    }
// CUSTOM PRIVATE
    /**
     * 
     * Carga los arreglos de colores al momento de crear un objeto Colors
     */
    private static void build() {
        // put your code here
        col[0] = Color.black;
        colname[0] = "black";
        col[1] = Color.blue;
        colname[1] = "blue";
        col[2] = Color.cyan;
        colname[2] = "cyan";
        col[3] = Color.darkGray;
        colname[3] = "dark gray";
        col[4] = Color.gray;
        colname[4] = "gray";
        col[5] = Color.green;
        colname[5] = "green";
        col[6] = Color.lightGray;
        colname[6] = "light gray";
        col[7] = Color.magenta;
        colname[7] = "magenta";
        col[8] = Color.orange;
        colname[8] = "orange";
        col[9] = Color.pink;
        colname[9] = "pink";
        col[10] = Color.red;
        colname[10] = "red";
        col[11] = Color.white;
        colname[11] = "white";
        col[12] = Color.yellow;
        colname[12] = "yellow";
    }
// GETTERS
    /**
     * Dado el nombre de un color, devuelve su correspondiente objeto java.awt.Color
     * 
     * @param strColor Nombre del color a buscar (debe coincidir con tabla de colores)
     * @return objeto Color correspondiente a strColor o null en caso de no encontrarse
     */
    public static Color getColor(final String strColor) {
        for(int i=0;i<col.length;i++) {
            if ( colname[i].equalsIgnoreCase(strColor) ) return col[i];
        }
        return null;
    }
// SETTERS
// CUSTOM PUBLIC    
    /**
     * 
     * Imprime tabla de colores en STDOUT
     */
    public static void printColors() {
        PrintStream o = System.out;
        o.println("TABLA DE COLORES");
        o.println("COLOR           R\tG\tB");
        StringBuffer str = new StringBuffer("");
        for(int i=0;i<col.length;i++) {
           str.append(colname[i]+"               ");
           o.println(str.substring(0,15)+" "+col[i].getRed()+"\t"+col[i].getGreen()+"\t"+col[i].getBlue());
           str.delete(0,str.length());
        }
        Color r = getColor("red");
        o.println("red             " + r.getRed() + "\t"+r.getGreen()+"\t"+r.getBlue());
    }
// MAIN
    public static void main(String[] arg) {
        Colors.printColors();
    }
}
