import java.io.*;
/**
 * La clase Console no funciona desde BlueJ 3.1.4 (ni en anteriores)
 * probado con JDK 7
 * System.console() devuelve siempre null
 * 
 * Clase estatica para ingreso de datos simples por teclado
 * 
 * @author G.Cherencio 
 * @version 1.0
 */
public class Consola {
    public static void println(String s) {
        System.out.println(s);
    }
    public static void print(String s) {
        System.out.print(s);
    }
    public static String readLine(String prompt,String[] val) {
        boolean ok=false;
        String s = null;
        do {
            s = readLine(prompt);
            for(String v : val) {
                if ( v.equals(s) ) {
                    ok=true;
                    break;
                }
            }
        } while(!ok);
        return s;
    }
    public static String readLine(String prompt) {
        print(prompt);
        return readLine();
    }
    public static String readLine() {
        String s = null;
        try {
            BufferedReader br = new BufferedReader(new InputStreamReader(new BufferedInputStream(System.in)));
            s = br.readLine();
        } catch(IOException ioe) {
        }
        return s;
    }
    public static int readInt(String prompt) {
        print(prompt);
        return readInt();
    }
    public static int readInt() {
        String s = null;
        boolean ok = false;
        int r = 0;
        while(!ok) {
            try {
                s = readLine();
                Integer d = new Integer(s);
                r = d;
                ok=true;
            } catch(NumberFormatException nfe) {
                System.err.println("["+s+"] no es int!");
            }
        }
        return r;
    }
    public static double readDouble(String prompt) {
        print(prompt);
        return readDouble();
    }
    public static double readDouble() {
        String s = null;
        boolean ok = false;
        double r = 0.0;
        while(!ok) {
            try {
                s = readLine();
                Double d = new Double(s);
                r = d;
                ok=true;
            } catch(NumberFormatException nfe) {
                System.err.println("["+s+"] no es double!");
            }
        }
        return r;
    }
}
