import java.io.*; // la clase PrintStream esta dentro de este package, para usarla, debo importar el package
/**
 * Muestra los valores por defecto de los tipos de datos primitivos en Java.
 * Realiza desplazamientos de bits con cada uno de los posibles valores byte (-128 to 127)
 * resultando en una actividad interesante para aquellos casos en donde se activa el "carry flag" del microprocesador
 * cuando se produce un desplazamientos de bits activados (y estos "se caen" x el desplazamiento), esto puede traducirse
 * en algo asi como "desplazo n bits a la derecha, si hay incremento (se activo el carry flag x desplazamiento de bits en "1"), 
 * debo sumar "1" al resultado. Observese, por ejemplo, el resultado de -127>>2 (esto si que no se ve en la curricula)
 * Muestra los valores en decimal y en binario (a traves de un metodo propio para traducir valores int a 32 digitos binarios) para
 * facilitar la observacion del fenomeno.
 * Observese tambien el cuidado que hay que tener cuando trabajamos al limite de la capacidad de un tipo de dato.
 * Parece ser que la clase Wrapper Byte no traduce numeros binarios de 8 digitos con signo, pero si lo hace con numeros binarios sin signo.
 * Uso de Clases: PrintStream, Byte, StringBuffer
 * Exceptions: NumberFormatException
 * Atencion! antes de ejecutar este programa, en Bluej active la Terminal Window (Ctrl-T, View\Show Terminal) y en la terminal active las
 * siguientes opciones: clear screen at method call, unlimited buffering  esto permitira ver todas la salida de este programa.
 * Atte. Guillermo Cherencio
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class Cuentas
{
    // instance variables - replace the example below with your own
    private boolean bo;
    private byte b;
    private short s;
    private int i;
    private long l;
    private float f;
    private double d;
    /**
     * Constructor for objects of class Cuentas
     */
    public Cuentas()
    {
        // initialise instance variables
        PrintStream o = System.out;  // System.out es de tipo PrintStream, puedo obtener una referencia de dicho tipo y tipear menos
        o.println("Veamos los valores por defecto:");
        o.println("boolean = " + bo);
        o.println("byte = " + b);
        o.println("short = " + s);
        o.println("int = " + i);
        o.println("long = " + l);
        o.println("float = " + f);
        o.println("double = " + d);
        // todos los valores byte
        o.println("Ahora veamos desplazamientos de bits:");
        for(byte i=-128;i<=127;i++) {
            int d2 = i>>2;
            int i2 = i<<2;
            int dd1 = i>>>1;
            int dd2 = i>>>2;
            o.println(i + "=" + fromByteToString(i) + " " + i + ">>2=" + d2 + "=" + fromIntToString(d2) + " " +
                                        i + "<<2="  + i2  + "=" + fromIntToString(i2)  + " " +
                                        i + ">>>1=" + dd1 + "=" + fromIntToString(dd1) + " " +
                                        i + ">>>2=" + dd2 + "=" + fromIntToString(dd2) + " " +
                                        " b=" + parseByte(fromByteToString(i)));
           /* por que esta instruccion? por que controlar el valor 127 de este loop y salir de forma no estructurada
            * de esta estructura repetitiva? pruebe de sacar esta instruccion y correr el programa. que es lo que ocurre
            * y por que? */
           if ( i == 127 ) break;
        }
//        for(short l=(short)-127;l<(short) 128;l++) o.println(l + "=" + fromShortToString(l) + " " + l + ">>2=" + (l>>2) + "=" + fromShortToString((l>>2)) + " " + l + "<<2=" + (l<<2) + "=" + fromShortToString((l<<2)) + " " + l + ">>>2=" + (l>>>2) + "=" + fromShortToString((l>>>2)));
    }

    /**
    * Comienzo la ejecucion de esta aplicacion creando un objeto de tipo Cuentas
    * 
    */
    public static void main(String[] args) {
        new Cuentas();
    }
    /**
    * Traduce un numero entero (byte) en un String que representa dicho numero
    * en 8 digitos binarios
    * 
    * @param  b byte a traducir
    * @return  String de 8 digitos binarios que representa a b
    */
    public String fromByteToString(byte b) {
        StringBuffer strb = new StringBuffer("");
        boolean negativo = false;
        if ( b < 0 ) { negativo = true; b *=-1; }
        if (b != 0) {
            while ( b >= 2 ) {
                strb.append( (b % 2) ); // agrego al StringBuffer el resto de la division x 2
                b /= 2;
            }
            strb.append((b % 2) );// agrego al StringBuffer el resto de la division x 2
            for(int i = 1,tope=strb.length();i<=7-tope;i++) strb.append('0');
            if ( negativo ) strb.append('1');
            else            strb.append('0');
            strb = strb.reverse();
        } else {
            strb.append("00000000");
        }
        return strb.toString();
    }
    /**
    * Traduce un numero entero (short) en un String que representa dicho numero
    * en 16 digitos binarios
    * 
    * @param  b short a traducir
    * @return  String de 16 digitos binarios que representa a b
    */
    public String fromShortToString(short b) {
        StringBuffer strb = new StringBuffer("");
        boolean negativo = false;
        if ( b < 0 ) { negativo = true; b *=-1; }
        if (b != 0) {
            while ( b >= 2 ) {
                strb.append( (b % 2) ); // agrego al StringBuffer el resto de la division x 2
                b /= 2;
            }
            strb.append((b % 2) );// agrego al StringBuffer el resto de la division x 2
            for(int i = 1,tope=strb.length();i<=15-tope;i++) strb.append('0');
            if ( negativo ) strb.append('1');
            else            strb.append('0');
            strb = strb.reverse();
        } else {
            strb.append("0000000000000000");
        }
        return strb.toString();
    }
    /**
    * Traduce un numero entero (int) en un String que representa dicho numero
    * en 32 digitos binarios
    * 
    * @param  b int a traducir
    * @return  String de 32 digitos binarios que representa a b
    */
    public String fromIntToString(int b) {
        StringBuffer strb = new StringBuffer("");
        boolean negativo = false;
        if ( b < 0 ) { negativo = true; b *=-1; }
        if (b != 0) {
            while ( b >= 2 ) {
                strb.append( (b % 2) ); // agrego al StringBuffer el resto de la division x 2
                b /= 2;
            }
            strb.append((b % 2) );// agrego al StringBuffer el resto de la division x 2
            for(int i = 1,tope=strb.length();i<=31-tope;i++) strb.append('0');
            if ( negativo ) strb.append('1');
            else            strb.append('0');
            strb = strb.reverse();
        } else {
            strb.append("00000000000000000000000000000000");
        }
        return strb.toString();
    }
    /**
    * Traduce un string que representa un numero binario de 8 digitos
    * en un valor de tipo byte
    * 
    * @param  strb String que representa nro. binario de 8 digitos
    * @return  el valor del nro binario en byte
    */
    public byte fromStringToByte(String strb) {
        int largo = strb.length();
        byte b = 0;
        if (largo != 8) return 0;
        boolean negativo = (strb.charAt(0) == '1');
        for(int i = 1;i<=7;i++) {
            if ( strb.charAt(i) == '1' ) b += (byte) Math.pow(2.0,(7.0-i));  
        }
        if ( negativo ) b *=-1;
        return b;
    }
    /**
    * Traduce un string que representa un numero binario
    * en un valor de tipo short utilizando la clase Wrapper Byte
    * 
    * @param  strb String que representa nro. binario
    * @return  el valor del nro binario en short
    */
    public short parseByte(String strb) {
       byte b;
       try {
           b = Byte.parseByte(strb,2);
       } catch(NumberFormatException nfe) {
           b = 0;
       }
       return b;
    }
} // final de clase Cuentas
