import java.io.*;
/**
 * Clase que sirve para hacer ingresos por teclado
 * y que se se va a utilizar desde entorno BlueJ
 * 
 * @author G.Cherencio
 * @version 1.0
 */
public class Consola {
    public static String getLinea(String prompt) {
        System.out.print(prompt);
        return getLinea();
    }

    public static String getLinea() {
        int car=0;
        StringBuffer sb = new StringBuffer("");
        try {
            while( (car = System.in.read()) != -1 && car != '\n' ) {
                // caracter valido ingresado
                sb.append((char) car);
            }
        } catch(IOException ioe) {
        }
        return sb.toString();
    }
    
    public static int getInt(String prompt) throws ConversionException {
        System.out.print(prompt);
        return getInt();
    }
    public static int getInt() throws ConversionException  {
        String linea = getLinea();
        int r = -1;
        try {
            r = Integer.parseInt(linea);
        } catch(NumberFormatException nfe) {
            //
//            System.err.println("Error, "+linea+" no es un entero!");
//             relanzo la exception como ConversionException con mensaje original + linea
//            throw new ConversionException(nfe.getMessage()+" ("+linea+")");
//              relanzo con mi propio mensaje
            throw new ConversionException(linea);
        }
        return r;
    }
    public static int getInt(String prompt,int desde,int hasta) throws ConversionException, RangeException {
        System.out.print(prompt);
        return getInt(desde,hasta);
    }
    
    public static int getInt(int desde,int hasta) throws ConversionException, RangeException {
        int r;
        try {
            r = getInt();
            if ( !(r >= desde && r <= hasta) ) throw new RangeException(r,desde,hasta);
        } catch(ConversionException ce) {
            throw ce;
        }
        return r;
    }
}
