
/**
 * Enumeration class SistemaMetrico 
 * Ejemplo de utilizacion de clase/tipo de dato enum para representar un conjunto
 * de valores constantes.
 * Observese el modificador de acceso del constructor, el metodo printf de la clase 
 * PrintStream, el ciclo for() para recorrer la lista de valores constantes.
 * No hay una llamada explicita al operador new, sin embargo, al interior de la clase
 * enum se crea un objeto por cada valor constante, que es posible recorrer a travs
 * del metodo values() de la clase java.lang.Enum (de la cual deriva SistemaMetrico,
 * aunque no lo haya escrito explicitamente.  Esto prohibe que se utilice la clausula 
 * public enum ... extends ..., porque la misma ya es una clase derivada).
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public enum SistemaMetrico {
    MILIMETRO  (1000.0),
    CENTIMETRO (100.0),
    DECIMETRO  (10.0),
    METRO      (1.0),
    DECAMETRO  (0.1),
    HECTOMETRO (0.01),
    KILOMETRO  (0.001);
    private final double conversion;
    /* 
     * observese que el constructor no es public, tiene un modificador de acceso default
     */
    SistemaMetrico(double indice) {
        conversion = indice;
    }
    public double convierto(double valor_en_metros) {
        return valor_en_metros * conversion;
    }
    public static void main(String[] args) {
       for( SistemaMetrico sm : SistemaMetrico.values() ) {
          System.out.printf("2500 metros equivale a %10.2f en %s\n",sm.convierto(2500),sm);
          // uso de 1$ para referirme al primer argumento (luego del formato) y 2$ para referirme al segundo argumento
          System.out.printf("2500 metros en %2$s equivale a %1$10.2f \n",sm.convierto(2500),sm);
       }
    }
       
}
