import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
/**
 * Manipulador generico de eventos Action de AppGUI
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class AccionesGUI implements ActionListener {
    private FAlumno f = null;
    private AppGUI app = null;
    private JTextField treg = null;
    private JTextField tleg = null;
    private JTextField tape = null;
    private JTextField tnom = null;

    public AccionesGUI() {
        f = new FAlumno();
    }
    public AccionesGUI(FAlumno f,AppGUI app) {
        this.f=f;
        this.app = app;
        treg = (JTextField) app.getComponent("treg");
        tleg = (JTextField) app.getComponent("tleg");
        tape = (JTextField) app.getComponent("tape");
        tnom = (JTextField) app.getComponent("tnom");
    }
    @Override
    public void actionPerformed(ActionEvent e) {
        // cual boton fue presionado?
        // como accedo a atributos o componentes dentro de AppGUI??
        if ( app == null ) {
            System.err.println("No puedo manejar eventos, app no indicada!");
            return;
        }
        Object fuente = e.getSource(); // fuente del evento
        if ( fuente instanceof JButton ) {
            // presiono un boton, pero cual??
            String accion = ((JButton) fuente).getActionCommand();
            if ( accion.equals("grabar") ) {
                try {
                    f.setLegajo(new Integer(tleg.getText()));
                    f.setApellido(tape.getText());
                    f.setNombre(tnom.getText());
                    f.setEstado((byte) 1);
                    f.grabar();
                    habilito(false);
                } catch(NumberFormatException nfe) {
                }
            } else if ( accion.equals("borrar") ) {
                f.setEstado((byte) 2);
                f.grabar();
                habilito(false);
            } else if ( accion.equals("listar") ) {
                StringBuffer sb = new StringBuffer();
                sb.append("<html><body><table border=1>");
                sb.append("<tr><td colspan=4><center>Listado de Alumnos</center></td></tr>");
                sb.append("<tr><td>Registro</td><td>Legajo</td><td>Apellido</td><td>Nombre</td></tr>");
                for(int i=0;i<f.getMaxReg();i++) {
                    if ( f.leer(i) && f.getEstado() == 1 ) {
                        sb.append("<tr><td>"+f.getUltimoRegistro()+"</td><td>"+f.getLegajo()+"</td><td>"+f.getApellido()+"</td><td>"+f.getNombre()+"</td></tr>");
                    }
                }
                sb.append("</table></body></html>");
                new ViewTxt(sb.toString());
            } else { // no se quien es!
            }
        } else if ( fuente instanceof JTextField ) {
            String spos = ((JTextField) app.getComponent("treg")).getText();
            try {
                Integer ipos = new Integer(spos);
                if ( f.leer(ipos) ) {
                    // 1 byte, 0 libre, 1 ocupado, 2 borrado
                    if ( f.getEstado() == 1 ) {
                        tleg.setText(""+f.getLegajo());
                        tape.setText(f.getApellido().trim());
                        tnom.setText(f.getNombre().trim());
                    } else {
                        tleg.setText("");
                        tape.setText("");
                        tnom.setText("");
                    }
                    habilito(true);
                }
            } catch(NumberFormatException nfe) {
                System.err.println("["+spos+"] no es un numero entero valido!");
            }

        }
        
    }
    /**
     * habilita/deshabilita los componentes de texto de la pantalla
     */
    public void habilito(boolean b) {
        tleg.setEnabled(b);
        tape.setEnabled(b);
        tnom.setEnabled(b);
    }
}
