import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.sql.*;

/**
 * Manipulador generico de eventos Action de AppGUI
 * para grabar en base de datos firebird usando DataIO
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class AccionesGUI3 implements ActionListener {
    private AppGUI3 app = null;
    private JTextField tleg = null;
    private JTextField tape = null;
    private JTextField tnom = null;

    public AccionesGUI3() {
    }
    public AccionesGUI3(AppGUI3 app) {
        this.app = app;
        tleg = (JTextField) app.getComponent("tleg");
        tape = (JTextField) app.getComponent("tape");
        tnom = (JTextField) app.getComponent("tnom");
    }
    @Override
    public void actionPerformed(ActionEvent e) {
        // cual boton fue presionado?
        // como accedo a atributos o componentes dentro de AppGUI??
        if ( app == null ) {
            System.err.println("No puedo manejar eventos, app no indicada!");
            return;
        }
        Object fuente = e.getSource(); // fuente del evento
        if ( fuente instanceof JButton ) {
            // presiono un boton, pero cual??
            String accion = ((JButton) fuente).getActionCommand();
            if ( accion.equals("grabar") ) {
                
                if ( !DataIO.executeQuery("INSERT INTO ALUMNO(LEGAJO,APELLIDO,NOMBRE) "+
                    "VALUES("+tleg.getText()+",'"+tape.getText()+"','"+tnom.getText()+"')") ) {
                       DataIO.executeQuery("UPDATE ALUMNO SET APELLIDO = '"+tape.getText()+"',"+
                        "NOMBRE = '"+tnom.getText()+"' WHERE LEGAJO = "+tleg.getText());
                       DataIO.doCommit();
                } else DataIO.doCommit();
                habilito(false);

            } else if ( accion.equals("borrar") ) {
                
                DataIO.executeQuery("DELETE FROM ALUMNO WHERE LEGAJO = "+tleg.getText());
                DataIO.doCommit();
                habilito(false);

            } else if ( accion.equals("listar") ) {
                StringBuffer sb = new StringBuffer();
                sb.append("<html><body><table border=1>");
                sb.append("<tr><td colspan=3><center>Listado de Alumnos</center></td></tr>");
                sb.append("<tr><td>Legajo</td><td>Apellido</td><td>Nombre</td></tr>");
                ResultSet rs = null;
                try {
                    rs = DataIO.getResultSet("SELECT * FROM ALUMNO ORDER BY APELLIDO,NOMBRE");
                    while(rs.next()) {
                        sb.append("<tr><td>"+rs.getString("legajo")+"</td><td>"+rs.getString("apellido")+"</td><td>"+rs.getString("nombre")+"</td></tr>");
                    }
                } catch(SQLException sqle) {
                } finally {
                    try { rs.close(); } catch(SQLException ee) {}
                }
                sb.append("</table></body></html>");
                new ViewTxt(sb.toString());
            } else { // no se quien es!
            }
        } else if ( fuente instanceof JTextField ) {
            String sleg = ((JTextField) app.getComponent("tleg")).getText();
            ResultSet rs = null;
            try {
                rs = DataIO.getResultSet("SELECT * FROM ALUMNO WHERE LEGAJO = "+sleg);
                if (rs.next()) {
                    tape.setText(rs.getString("Apellido"));
                    tnom.setText(rs.getString("Nombre"));
                } else {
                    tape.setText("");
                    tnom.setText("");
                }
                habilito(true);
            } catch(SQLException sqle) {
            } finally {
                try { rs.close(); } catch(SQLException ee) {}
            }
        }
        
    }
    /**
     * habilita/deshabilita los componentes de texto de la pantalla
     */
    public void habilito(boolean b) {
        //tleg.setEnabled(b);
        tape.setEnabled(b);
        tnom.setEnabled(b);
    }
}
