
/**
 * Clase POJO que representa un Alumno
 * 
 * @author G.Cherencio
 * @version 1.0
 */
public class Alumno {
    
    // atributos de instancia
    //private byte estado;   // 1 byte, 0 libre, 1 ocupado, 2 borrado
    private int legajo;    // 5 bytes
    private String ape;    // 100 bytes
    private String nom;    // 100 bytes
    //                      ------
    //                        206 bytes total largo de registro

    /**
     * Constructor for objects of class Alumno
     */
    public Alumno() {
        // initialise instance variables
        this(0);
    }
    
    /**
     * Constructor for objects of class Alumno
     */
    public Alumno(int l) {
        this(l,"");
    }
    /**
     * Constructor for objects of class Alumno
     */
    public Alumno(int l,String ap) {
        this(l,ap,"");
    }
    /**
     * Constructor for objects of class Alumno
     */
    public Alumno(int l,String ap,String no) {
        setLegajo(l);setApellido(ap);setNombre(no);        
    }
    
    // setters
    // this.estado es la propiedad o atributo estado, 
    // mientras que estado es el argumento estado del metodo setEstado()
    //public void setEstado(byte estado) { this.estado = estado; } 
    public void setLegajo(int l) { legajo = l; }
    public void setApellido(String a) { ape = a; }
    public void setNombre(String n) { nom = n; }

    // getters
    //public byte getEstado() { return estado; }
    public int getLegajo() { return legajo; }
    public String getApellido() { return ape; }
    public String getNombre() { return nom; }

    /*
     * Representacion String de un objeto FAlumnno
     */
    @Override
    public String toString() {
        return "["+getLegajo()+","+getApellido().trim()+","+getNombre().trim()+"]";
    }
    
}
