
import java.util.*;
import java.text.*;
/**
 * Clase aplicacion de consola para grabar objetos FAlumno
 * 
 * @author G. Cherencio 
 * @version 1.0
 */
public class AppConsola {
    class Interior {
        public void hago() {
            System.out.println("hago() en clase inner!");
        }
    }
    public void uso() {
        Interior i = new Interior();
        i.hago();
    }
    public static void main(String[] arg) {
        Volador v = new Avion();
        Volador vv = new Volador() {
            public void volar() {
                System.out.println("estoy volando desde clase anonima!");
            }
        };
        
        v.volar();
        vv.volar();
        AppConsola ap = new AppConsola();
        ap.uso();

        Consola.ingresoLinea("presione intro para continuar");

        int opcion;
        do {
            opcion = Consola.menu(new String[] { "1. Crear Archivo","2. Alta", "3. Baja", "4. Cambio", 
                                                 "5. Listar","6. Jugar con Fechas","99. Salir" });
            switch(opcion) {
                case 1:
                    FAlumno.crear();
                    break;
                case 2:
                    alta();
                    break;
                case 3:
                    baja();
                    break;
                case 4:
                    cambio();
                    break;
                case 5:
                    listar();
                    break;
                case 6:
                    jugar();
                    break;
                case 99:
                    break;
                default:
                    System.err.println("Opcion "+opcion+" incorrecta!");
            }
        } while(opcion != 99);
        System.out.println("Fin!");
    }
    
    public static void alta() {
        int pos = Consola.ingresoInt("Posicion (0-"+(FAlumno.getMaxReg()-1)+"):");
        int leg = Consola.ingresoInt("Legajo:");
        String ape = Consola.ingresoLinea("Apellido:");
        String nom = Consola.ingresoLinea("Nombre:");
        FAlumno.abrir();
        FAlumno f = new FAlumno(leg,ape,nom);
        f.setEstado((byte) 1);
        f.grabar(pos);
        FAlumno.cerrar();
    }
    public static void baja() {
        FAlumno.abrir();
        int pos = Consola.ingresoInt("Posicion (0-"+(FAlumno.getMaxReg()-1)+"):");
        FAlumno f = new FAlumno();
        f.leer(pos);
        if ( f.getEstado() == 1 ) { // si esta ocupado...
            System.out.println(f); // muestro objeto FAlumno leido!
            if ( Consola.ingresoSiNo("Confirma borrar a este Alumno? (S/N):") ) {
                f.setEstado((byte) 2); // cambio estado a borrado
                f.grabar(pos);
                System.out.println("Alumno dado de baja!");
            }
        }
        FAlumno.cerrar();
    }
    public static void cambio() {
        FAlumno.abrir();
        int pos = Consola.ingresoInt("Posicion (0-"+(FAlumno.getMaxReg()-1)+"):");
        FAlumno f = new FAlumno();
        f.leer(pos);
        if ( f.getEstado() == 1 ) { // si esta ocupado...
            System.out.println(f); // muestro objeto FAlumno leido!
        }
        int leg = Consola.ingresoInt("Legajo:");
        String ape = Consola.ingresoLinea("Apellido:");
        String nom = Consola.ingresoLinea("Nombre:");
        f.setEstado((byte) 1);
        if ( leg != 0 ) f.setLegajo(leg);
        if ( !ape.equals("") ) f.setApellido(ape);
        if ( !nom.equals("") ) f.setNombre(nom);
        System.out.println(f); // muestro objeto FAlumno modificado!
        if ( Consola.ingresoSiNo("Confirma modificar a este Alumno? (S/N):") ) {
            f.grabar(pos);
            System.out.println("Alumno modificado!");
        }
        FAlumno.cerrar();
    }
    public static void listar() {
        FAlumno.abrir();
        FAlumno f = new FAlumno();
        for(int i=0;i<FAlumno.getMaxReg();i++) {
            f.leer(i);
            if ( f.getEstado() == 1 ) {
                System.out.println(""+i+" "+f);
            }
        }
        FAlumno.cerrar();
    }

    public static void jugar() {
        // jugamos con fechas
        // java.util.Date
        // java.util.Calendar java.util.GregorianCalendar
        // java.text.DateFormat java.text.SimpleDateFormat
        
        Date today = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
        
        // paso un obj Date a String utilizando un formato de fecha determinado
        System.out.println("Hoy es: "+sdf.format(today));
        
        String sfecha = Consola.ingresoLinea("Ingrese Fecha (dd/mm/yyyy):");
        Date fechaIngresada = null;
        try {
            // pruebe ingresando fechas como 31/06/2014, 50/06/2014, etc
            fechaIngresada = sdf.parse(sfecha);
            System.out.println("Ud ingreso: "+sdf.format(fechaIngresada));
        } catch(ParseException pe) {
            System.err.println("["+sfecha+"] no es una fecha en formato dd/mm/yyyy ["+fechaIngresada+"]");
        }
        
        // fecha a partir de anio, mes, dia
        // atencion!! el mes en GregorianCalendar es 0 based, es decir 5, es junio
        GregorianCalendar gc = new GregorianCalendar(2014,5,30);
        Date fechaDeEntero = gc.getTime();
        System.out.println("Ud hizo fecha a partir de entero: "+sdf.format(fechaDeEntero));
        
        // sumo 15 dias a la fecha 30/06/2014
        gc.add(Calendar.DAY_OF_MONTH,15);
        System.out.println("Sumo 15 dias a la fecha anterior: "+sdf.format(gc.getTime()));
        
    }
    
}
