import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
/**
 * Clase aplicacion grafica para probar FAlumno
 * Creamos interfase grafica con Swing
 * 
 * @author G. Cherencio 
 * @version 1.0
 */
public class AppGUI {
    // paso 1, diseñar GUI en papel
    // paso 2, crear obj componentes/contenedores
    // objetos contenedores
    private JFrame fr       = new JFrame("Alumnos");
    private JPanel pnorte   = new JPanel();
    private JPanel psur     = new JPanel();
    private JPanel pcentro  = new JPanel();
    // componentes
    private JLabel lreg     = new JLabel("Registro:");
    private JLabel lleg     = new JLabel("Legajo:");
    private JLabel lape     = new JLabel("Apellido:");
    private JLabel lnom     = new JLabel("Nombre:");
    
    private JTextField treg = new JTextField(5);
    private JTextField tleg = new JTextField();
    private JTextField tape = new JTextField();
    private JTextField tnom = new JTextField();
    
    private JButton bgra = new JButton("Grabar");
    private JButton bbor = new JButton("Borrar");
    private JButton blis = new JButton("Listar");
    
    // objeto alumno a persistir
    private FAlumno f = new FAlumno();
    
    // componentes a ser accedidos desde fuera de esta interfase
    private Map<String,JComponent> map = new HashMap<String,JComponent>();

    
    public AppGUI() {
        
        System.out.println("Inicio AppGUI()");

        // Cargamos coleccion con los Componentes de esta interfase
        // estos objetos deben cargarse en el map antes de crear un objeto de tipo AccionesGUI
        map.put("treg",treg);
        map.put("tleg",tleg);
        map.put("tape",tape);
        map.put("tnom",tnom);
        
        // en un primer momento, se deshabilitan los campos de texto
        tleg.setEnabled(false);
        tape.setEnabled(false);
        tnom.setEnabled(false);
        
        // paso 3, setear layout managers
        fr.setLayout(new BorderLayout());
        pnorte.setLayout(new FlowLayout(FlowLayout.CENTER));
        psur.setLayout(new FlowLayout(FlowLayout.CENTER));
        pcentro.setLayout(new GridLayout(3,2));
        
        // paso 4, agregar componentes a contenedores
        pnorte.add(lreg);
        pnorte.add(treg);
        
        psur.add(blis);
        psur.add(bbor);
        psur.add(bgra);
        
        pcentro.add(lleg);
        pcentro.add(tleg);
        pcentro.add(lape);
        pcentro.add(tape);
        pcentro.add(lnom);
        pcentro.add(tnom);
        
        fr.getContentPane().add(pnorte,"North");
        fr.getContentPane().add(psur,"South");
        fr.getContentPane().add(pcentro,"Center");
        fr.getContentPane().add(new JLabel("     "),"West");
        fr.getContentPane().add(new JLabel("     "),"East");
        
        // paso 5, implementar manipuladores de eventos
        // indico una accion para cada boton
        treg.setActionCommand("posicionar");
        blis.setActionCommand("listar");
        bgra.setActionCommand("grabar");
        bbor.setActionCommand("borrar");
        AccionesGUI ag = new AccionesGUI(f,this);
        treg.addActionListener(ag);
        blis.addActionListener(ag);
        bgra.addActionListener(ag);
        bbor.addActionListener(ag);
        /*
        blis.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("Ud. presiono el boton de Listar!");
            }
        });
        */
        
       
        // que termine la jvm cuando se presione el boton close en la ventana
        //fr.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        // paso 6, setear tamaño contenedor principal
        fr.setSize(500, 200);
        
        // paso 7, visualizar el contenedor principal
        fr.setLocationRelativeTo(null); // para que se centre el JFrame en la pantalla
        fr.setResizable(false); // permite/no permite cambiar el tamaño de la pantalla
        fr.setVisible(true);
        
        System.out.println("Fin AppGUI()");
        
    }

    public JComponent getComponent(String name) {
        return map.get(name);
    }
    public static void main(String[] arg) {
        //
        System.out.println("Inicio main()");
        new AppGUI();
        System.out.println("Fin main()");
    }
}
