
/**
 * Clase abstracta que agrega el concepto de byte de estado en
 * archivo de acceso directo, por ello, deriva de FObject.
 * Asume que el byte de estado es el primer byte del registro.
 * 
 * @author G. Cherencio.
 * @version 1.0
 */
public abstract class FObjectEstado extends FObject {
    // atributos de instancia
    private byte estado;   // 1 byte, 0 libre, 1 ocupado, 2 borrado

    public void setEstado(byte estado) { this.estado = estado; } 
    public void setEstado(byte[] registro) { setEstado(registro[0]); } 
    public byte getEstado() { return estado; }
    
    /*
     * Representacion String de un objeto FObject
     */
    @Override
    public String toString() {
        return super.toString()+"[st="+getEstado()+"]";
    }
}
