import java.util.*;
import java.io.*;
/**
 * FObjectPk agrega el concepto de clave primaria
 * a la persistencia de este objeto en disco.
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class FObjectPk extends FObjectRegistro {
    // instance variables - replace the example below with your own
    private Map<Integer,Integer> mapidx = new HashMap<Integer,Integer>();
    private FAlumno fa = new FAlumno();
    private boolean idxOk = true;
    
    

    /**
     * Constructor for objects of class FObjectPk
     */
    public FObjectPk() {
        // initialise instance variables
        fa.setArchivo("alumno.dat2");
        fa.setLargoReg(206);
        if ( new File("alumno.dat2").exists() ) {
            try {
                RandomAccessFile raf = new RandomAccessFile("alumno.dat2","r");
                int nr = (int) raf.length()/fa.getLargoReg();
                fa.setMaxReg(nr);
                raf.close();
            } catch(IOException ioe) {
            }
        } else fa.setMaxReg(0); 
        fa.cerrar();
        fa.init();
        cargarIndice();
    }

    public void cargarIndice() {
        mapidx.clear();
        RandomAccessFile raf = null;
        try {
            raf = new RandomAccessFile("alumno.idx","rw");
            do {
                int legajo = raf.readInt();
                int nreg   = raf.readInt();
                mapidx.put(legajo,nreg);
            } while(true);
            
        } catch(IOException ioe) {
        } finally {
            try { raf.close(); } catch(IOException ioe2) {}
        }
    }

    public synchronized void grabarIndice() {
        if ( idxOk ) {
            System.out.println("grabarIndice(): no es necesario grabar!");
            return;
        }
        RandomAccessFile raf = null;
        try {
            new File("alumno.idx").delete();
            raf = new RandomAccessFile("alumno.idx","rw");
            Set<Integer> si = mapidx.keySet();
            Iterator<Integer> ii = si.iterator();
            while(ii.hasNext()) {
                Integer leg = ii.next();
                Integer reg = mapidx.get(leg);
                raf.writeInt(leg);
                raf.writeInt(reg);
            }
        } catch(IOException ioe) {
        } finally {
            try { raf.close(); } catch(IOException ioe2) {}
            idxOk=true;
        }
    }
    
    public FAlumno getFAlumno() { return fa; }
    public Map<Integer,Integer> getMap() { return mapidx; }
    
    public boolean grabar(int legajo) {
System.out.println("FObjectPk grabar() 1!");            
        if ( mapidx.containsKey(legajo) ) {
            fa.grabar();
            if ( fa.getEstado() == 2 ) { 
                mapidx.remove(legajo);
                idxOk=false;
            }
        } else {
System.out.println("FObjectPk grabar() 2!");            
            int nr = fa.getMaxReg();
            mapidx.put(legajo,nr); // nuevo numero de registro
            idxOk=false;
            fa.setMaxReg(nr+1);
            fa.grabar(nr);
        }
        return true;
    }
    public boolean leer(int legajo) {
        if ( mapidx.containsKey(legajo) ) {
            fa.leer(mapidx.get(legajo));
            return true;
        } else return false;
    }
    
    public void listar() {
        System.out.println("Listado de Alumnos");
        Set<Integer> si = mapidx.keySet();
        Iterator<Integer> ii = si.iterator();
        while(ii.hasNext()) {
            Integer leg = ii.next();
            if (leer(leg)) {
                System.out.println(fa);
            }
        }
    }
}
