
/**
 * Hilo implementado derivando de la clase Thread.
 * Hilo que hace sleep() y graba indice de tipo FObjectPk y luego vuelve a empezar
 * hasta que desde el exterior le indican que ya no es necesario 
 * continuar grabando
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class TareaGrabar extends Thread {
    private boolean proceso = true;
    private FObjectPk f;
    private long milis = 30000L;
    
    public TareaGrabar(FObjectPk ff) {
        this(ff,30);
    }
    public TareaGrabar(FObjectPk ff,int segundos) {
        milis = segundos * 1000L;
        f = ff;
    }
    
    @Override
    public void run() {
        while(proceso) {
            try {
                sleep(milis);
                System.out.println("obj TareaGrabar grabando indice...");
                f.grabarIndice();
            } catch(Exception e) {
            }
        }
    }
    
    public void setProceso(boolean b) {
        proceso = b;
    }
}