import java.util.*;
import java.text.*;
/**
 * Write a description of class Model here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Model {
    // TreeMap implements SortedMap -> claves ordenadas
    private Map<Integer,Cliente> map = new TreeMap<Integer,Cliente>();
    private RFile rf = new RFile("clientes.dat",64,100); // archivo RFile, 64bytes de largo en cada registro, 100 registros
    
    // CUSTOM
    public boolean load() {
        byte[] buffer;
        Cliente c;
        for(int i=0;i<rf.getNRegistro();i++) { // mientras i<cantidad de registros
            buffer = rf.leer(i);
            if ( buffer[0] == 0 ) break; // si encuentro un 0 para
            c = deserialize(buffer); // convierte un arreglo de bytes en un objeto Cliente
            if ( c.getSt() == 1 ) map.put(i,c); // si se encuntra un 1 (estado ocupado) se inserta el registro en el map mediante put
        }
        return true;
    }
    
    // tomo la coleccion (map) cargado en memoria y lo guardo en el archivo
    // utilizando la clase RFile
    public boolean save() {
        Set<Integer> s = map.keySet();
        byte[] buffer;
        for(Integer nr : s) {
            int nro_registro = nr;
            if ( nro_registro > rf.getNRegistro() ) {
                System.err.println("Se excedio el limite del archivo!\n");
                break;
            }
            Cliente c = map.get(nr);
            int st = c.getSt();
            buffer = serialize(c);
            switch(st) {
                case 1: // ocupado
                    rf.grabar(nro_registro,buffer);
                    break;
                case 2: // borrado
                    buffer[0]='2'; // borrado en el archivo
                    rf.grabar(nro_registro,buffer);
                    break;
                case 3: // modificado
                case 4: // nuevo
                    buffer[0]='1'; // ocupado en el archivo
                    rf.grabar(nro_registro,buffer);
                    break;
                default:
                    System.err.println("Estado de Cliente desconocido ("+st+")\n");
            }
        }
        return true;
    }
    
    // permite que desde el exterior se agreguen,quiten,borren,etc objetos Cliente contenidos en el map
    public Map<Integer,Cliente> getMap() { return map; }
    
    // recorre vector y castea String a Byte caracter por caracter
    public byte[] castSerialize(byte[] b, int pos, String s,int largo) {
        for(int z=0;z<pos && z<largo && z<s.length();z++,pos++) b[pos] = (byte) s.charAt(z);
        return b;
    }
    
    public void clear(byte[] b) {
        // lleno vector de nulos o valores 0 binario
        for(int i=0;i<b.length;i++) b[i]=(byte) 0;
    }    
    // transforma objeto Cliente en un arreglo de bytes
    public byte[] serialize(Cliente c) {
        byte[] b = new byte[64];
        clear(b);
        int i=0;
        b[i] = (byte) ((char) (c.getSt()+'0')); // status
        i=1; // codigo
        String scod = "" + c.getCodigo();
        castSerialize(b,i,scod,5);
        i=6; // descripcion
        String sdesc = c.getDescr();
        castSerialize(b,i,sdesc,45);
        i=51; // saldo
        DecimalFormat df = new DecimalFormat("#########0.00");
        String ssaldo = df.format(c.getSaldo());
        System.out.println("saldo=["+ssaldo+"]");
        castSerialize(b,i,ssaldo,13);
        return b;
    }
    // transforma un arreglo de bytes en objeto Cliente
    public Cliente deserialize(byte[] b) {
        int i;
        Cliente c = new Cliente();
        i=0;
        c.setSt((int) (b[i]-'0'));
        StringBuilder sb = new StringBuilder();
        i=1;
        for(int z=0;(b[i] != (byte) 0) && z < 5;z++,i++) sb.append((char) b[i]);
        c.setCodigo(new Integer(sb.toString())); // setea el codigo
        sb.delete(0,sb.length()); //borra todos los caracteres
        i=6;
        for(int z=0;(b[i] != (byte) 0) && z < 45;z++,i++) sb.append((char) b[i]);
        c.setDescr(sb.toString()); // setea la descr
        sb.delete(0,sb.length()); // borra todos los caracteres
        i=51;
        for(int z=0;(b[i] != (byte) 0) && z < 45;z++,i++) sb.append((char) b[i]);
        try {
            Number n = new DecimalFormat("#########0.00").parse(sb.toString());
            c.setSaldo(n.doubleValue());
        } catch(ParseException pe) {
            System.err.println("ParseException en ("+sb.toString()+"), se asume saldo=0.0");
            c.setSaldo(0);
        }
        return c;
    }
    
    // cierra archivo RFile
    public void close() { rf.cerrar(); }
}
