/**
 * Esta interfase obliga a la clase que pretenda implementarla (en este caso Auto la implementa)
 * a implementar el codigo correspondiente al metodo public String getName().
 * Resulta que este metodo fue implementado en la clase Vehiculo.
 * Resulta que Auto deriva de Vehiculo y hereda este metodo.
 * Entonces Auto puede implementar esta interfase sin mayor esfuerzo porque ya cuenta con la implementacion de 
 * este metodo.
 * Esto no es una buena practica porque hace a un diseo confuso, no obstante compila y todo
 * converge en una unica implementacion del metodo public String getName(), independientemente
 * de quien nos este obligando a implementar dicho metodo.
 * 
 * @author G. Cherencio
 * @version 1.0
 */

public interface AlgoRompible {
   public String getName();
}
