/**
 * Auto deriva de Vehiculo
 * Tambien implementa la interfase Cosa y AlgoRompible
 * Como, a su vez, Cosa deriva de SuperCosa, entonces tambien debera implementar todos los 
 * metodos declarados en SuperCosa
 * Lea los comentarios asociados a estas interfases y clases.
 * Observe que aqui no hay implementacion del metodo public String getName() ya que este
 * es heredado de Vehiculo y al mismo tiempo, obligado a implementar por las interfases.
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class Auto extends Vehiculo implements Cosa, AlgoRompible
{
    /**
     * Este constructor llama al constructor de la clase Vehiculo
     * @param nombre Nombre del Auto que sera pasado al constructor de la superclase
     */
    public Auto(String nombre)
    {
        // initialise instance variables
        super(nombre);
    }
    /**
     * An example of a method - replace this comment with your own
     * 
     * @param  y   a sample parameter for a method
     * @return     the sum of x and y 
     */
    // debo implementar el metodo declarado en interfase Cosa
    // pero resulta que ese mismo es heredado de Vehiculo, si cambio el nombre del metodo getName() por getName2(),
    // este codigo dejaria de compilar!
    public static void main(String[] args) {
        Auto a = new Auto("autito");
        if ( a instanceof Object ) System.out.println("Auto es un Object");     // ya que deriva de esta clase
        if ( a instanceof Cosa ) System.out.println("Auto es una Cosa");        // ya que implementa dicha interfase
        if ( a instanceof AlgoRompible ) System.out.println("Auto es un AlgoRompible"); // ya que implementa dicha interfase
        if ( a instanceof SuperCosa ) System.out.println("Auto es un SuperCosa"); // ya que implementa Cosa que a su vez es SuperCosa
        if ( a instanceof Vehiculo ) System.out.println("Auto es un Vehiculo"); // ya que deriva de esta clase
        if ( a instanceof Auto ) System.out.println("Auto es un Auto");         // ya que es si mismo
        System.out.println("Auto: " + a.getName() + " vale $ " + a.valor);      // de donde salio valor? 
        System.out.println("Todo Auto vale $ " + Auto.valor); // ya que valor automaticamente es public static final
        // la linea siguiente no compila!, no puedo cambiar el valor a algo final!
        //Auto.valor = 45;
        // la linea siguiente tampoco compila!
        //a.valor = 44;
    }
/*  Este codigo no compila!! por que?
    public void setValor(int valor) {
        this.valor = valor;
    }
*/    
}

