
/**
 * Esta interfase demuestra que se puede aplicar el concepto de herencia a las
 * interfases, incluso a interfases vacias. 
 * Cuando una interfase deriva de otra no significa que la interfase derivada debe
 * implementar los metodos declarados por la interfase padre o superclase (o habra 
 * que llamarla superinterfase?); el que esta obligado a implementar todos los metodos
 * de la interfase X mas todos los metodos de sus ancestros sera la clase que pretenda
 * implementar la interfase X.
 * Observese en la clase Auto, que la constante valor es utilizada como si hubiera sido
 * declarada public static final int valor = 100; De hecho, las constantes declaradas en
 * una interfase se consideran public static.
 * Provoca una especie de "colision" de nombres de metodos, porque esta interfase dice: 
 * "toda clase que implemente la interfase Cosa debe implementar el metodo public String
 * getName()", en este caso, resulta que ese mismo metodo, con esa misma signatura es heredado
 * en la clase Auto, ya que es implementado en la superclase Vehiculo.
 * Lo mismo sucede con respecto a la interfase AlgoRompible.
 * Esto no es una buena practica porque hace a un diseo confuso, no obstante compila y todo
 * converge en una unica implementacion del metodo public String getName(), independientemente
 * de quien nos este obligando a implementar dicho metodo.
 * 
 * @author G. Cherencio
 * @version 1.0
 */

public interface Cosa extends SuperCosa {
	public String getName();
	final int valor = 100;
}
