
/**
 * Vehiculo es superclase de la clase Auto
 * Declara atributos de tipo private que luego podran ser accedidos indirectamente
 * desde la clase Auto a traves de la utilizacion de los metodos public.
 * Observese en Auto que la llamada al metodo getName() no da error a pesar de que
 * nombre es un atributo private en Vehiculo.
 * Si bien es cierto que se hereda todo lo no private, en realidad un objeto de clase
 * Auto contendra en su interior Object + Vehiculo + Auto + la implementacion de los 
 * metodos y constantes declarados en las interfases: SuperCosa, Cosa y AlgoRompible
 * aunque aquello private, al interior del objeto Auto no sera directamente accesible,
 * sino a traves de los metodos que permitan manipular de forma segura estos atributos
 * private (encapsulacion, hiding information)
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class Vehiculo {
    private int nroRuedas;
    private String nombre;
    public Vehiculo(String nombre) {
        this.nombre = nombre;
        this.nroRuedas = 4;
    }
    public String getName() {
        return nombre;
    }
    public int nroRuedas() {
        return nroRuedas;
    }
    public void setRuedas(int nroRuedas) {
        this.nroRuedas = nroRuedas;
    }
}
