
/**
 * Caso 1 
 * Interaccion entre objeto de tipo Camion y objeto de tipo Marca
 * El objeto de tipo Camion guarda un String con el nombre de la Marca, una vez que asignamos dicho string
 * el objeto de tipo Marca puede cambiar su nombre, pero Camion no reacciona a dicho cambio, porque el objeto
 * de tipo Camion guarda en su atributo marca una referencia al string devuelto por el metodo getNombre() del
 * objeto de tipo Marca.
 * El hecho de cambiar el estado del objeto Marca no implica que cambie el atributo marca del objeto Camion (ya que
 * este continua apuntando al anterior string que representaba el nombre de la marca)
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class Camion
{
    private int modelo;
    private String nombre;
    public String marca;
    /**
     * Constructor for objects of class Camion
     */
    public Camion(String nombre)
    {
        // initialise instance variables
        this.nombre = nombre;
    }

    /**
     * An example of a method - replace this comment with your own
     * 
     * @param  y   a sample parameter for a method
     * @return     the sum of x and y 
     */
    public void setModelo(int anio) {
        // put your code here
        modelo = anio;
    }
    public int getModelo() {
        return modelo;
    }
    public String getNombre() {
        return nombre;
    }
    
    public static void main(String[] args) {
        Camion cam = new Camion("EuroCargo");
        cam.setModelo(1998);
        Marca marca = new Marca("Ford");
        cam.marca = marca.getNombre();
        System.out.println("Camion: " + cam.getNombre() + " Modelo: " + cam.getModelo() + " Marca: " + cam.marca);
        System.out.println("Marca: " + marca.getNombre() );
        // cambio obj Marca
        marca.setNombre("VW");
        System.out.println("Camion: " + cam.getNombre() + " Modelo: " + cam.getModelo() + " Marca: " + cam.marca);
        System.out.println("Marca: " + marca.getNombre() );
    }
}

class Marca {
    private String nombre;
    Marca(String marca) {
        setNombre(marca);
    }
    public String getNombre() {
        return nombre;
    }
    public void setNombre(String nombre) {
        this.nombre = nombre;
    }
}