/**
 * Caso 2 
 * Interaccion entre objeto de tipo Camion y objeto de tipo Marca
 * El objeto de tipo Camion guarda una referencia a un objeto de tipo Marca.
 * El objeto de tipo Camion tiene el metodo getMarcaNombre() que devuelve aquello que devuelve el metodo getNombre() del objeto Marca
 * del cual guarda una referencia.
 * Por lo tanto, cada vez que se cambia un objeto de tipo Marca y se le pregunta a un objeto de tipo Cambio el nombre de su marca, este
 * devuelve el dato actualizado, ya que, accede a la informacion que en ese instante tiene el objeto de tipo Marca a traves de la referencia
 * que guarda Camion a un objeto de tipo Marca.
 * Este es un caso de Asociacion o Composicion, "un objeto de tipo Camion tiene conocimiento de un objeto de tipo Marca" es una relacion de tipo "has a"
 * La version 1.0 no se trataba de una agregacion o composicion sino que Camion guardaba un String con el nombre de la Marca, pero dicho String
 * no se actualizaba cada vez que habia un cambio en el interior del objeto Marca.
 * 
 * @author G. Cherencio
 * @version 2.0
 */
public class Camion
{
    private int modelo;
    private String nombre;
    private Marca marca;
    /**
     * Constructor for objects of class Camion
     */
    public Camion(String nombre)
    {
        // initialise instance variables
        this.nombre = nombre;
    }

    /**
     * An example of a method - replace this comment with your own
     * 
     * @param  y   a sample parameter for a method
     * @return     the sum of x and y 
     */
    public void setModelo(int anio) {
        // put your code here
        modelo = anio;
    }
    public int getModelo() {
        return modelo;
    }
    public String getNombre() {
        return nombre;
    }
    public void setMarca(Marca marca) {
        this.marca = marca;
    }
    public String getNombreMarca() {
        return marca.getNombre();
    }
    
    public static void main(String[] args) {
        Camion cam = new Camion("EuroCargo");
        cam.setModelo(1998);
        Marca marca = new Marca("Ford");
        cam.setMarca(marca);
        System.out.println("Camion: " + cam.getNombre() + " Modelo: " + cam.getModelo() + " Marca: " + cam.getNombreMarca());
        System.out.println("Marca: " + marca.getNombre() );
        // cambio obj Marca
        marca.setNombre("VW");
        System.out.println("Camion: " + cam.getNombre() + " Modelo: " + cam.getModelo() + " Marca: " + cam.getNombreMarca());
        System.out.println("Marca: " + marca.getNombre() );
    }
}

class Marca {
    private String nombre;
    Marca(String marca) {
        setNombre(marca);
    }
    public String getNombre() {
        return nombre;
    }
    public void setNombre(String nombre) {
        this.nombre = nombre;
    }
}